#include <avr/io.h>

int adc_convert(unsigned char channel) {

	if ((channel < 0) | (channel > 7)) channel = 2;

	unsigned char value_ADCL = 0;
	unsigned char value_ADCH = 0;

	ADCL = 0;
	ADCH = 0;

	ADMUX  = (0 << REFS1)|(1 << REFS0)|(0 << ADLAR)|(0 << MUX4);

	ADMUX |= (((channel & 0b00001000) >> 3) << MUX3);
	ADMUX |= (((channel & 0b00000100) >> 2) << MUX2);
	ADMUX |= (((channel & 0b00000010) >> 1) << MUX1);
	ADMUX |= ( (channel & 0b00000001)       << MUX0);

	ADCSRA  = (0<<ADIE)|(1<<ADEN)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);	

	ADCSRA |= (1<<ADSC);

	while ((ADCSRA & (1<<ADIF))==0) {
	}

	value_ADCL = ADCL;	
	value_ADCH = ADCH;	

	return ((value_ADCH << 8) | value_ADCL);
}
